#include <bits/stdc++.h>

using namespace std;

// Motto: Cu cat e cerinta mai scurta cu atat e mai usoara problema.
// sunt cooked

const int MAXN = 3'000;
const int MOD = 1'000'000'007;
const int MAXVAL = 100'000;
const int MAXNCF = 101;
const int BASE = 1'000'000'000;
const int MAXM = 100'000;

int fr[MAXVAL + 1];

// de ce????????????????????????????????
// cum dracu se scriu numere mari
// hai ca nu e asa de rau
struct BigNumber {
  int ncf, cf[MAXNCF];

  void read() {
    for(int i = 0; i < ncf; i++) {
      cf[i] = 0;
    }
    string s;
    cin >> s;
    ncf = 0;
    for(int i = (int)s.size(); i > 0; i -= 9) {
      int stop = max(0, i - 9), nr = 0;
      for(int j = stop; j < i; j++) {
        nr = nr * 10 + (s[j] - '0');
      }
      cf[ncf++] = nr;
    }
    for(int st = 0, dr = ncf - 1; st < dr; st++, dr--) {
      swap(cf[st], cf[dr]);
    }
  }

  void reset() {
    for(int i = 0; i < ncf; i++) {
      cf[i] = 0;
    }
    ncf = cf[0] = 1;
  }

  void operator = (const BigNumber &other) {
    for(int i = 0; i < ncf; i++) {
      cf[i] = 0;
    }
    ncf = other.ncf;
    for(int i = 0; i < ncf; i++) {
      cf[i] = other.cf[i];
    }
  }

  void operator += (const BigNumber &other) {
    int new_ncf = 0;
    long long t = 0;
    while(t > 0 || new_ncf < ncf || new_ncf < other.ncf) {
      if(new_ncf == MAXNCF) {
        break;
      }
      t += other.cf[new_ncf] + cf[new_ncf];
      cf[new_ncf++] = t % BASE;
      t /= BASE;
    }
    ncf = new_ncf;
  }

  bool operator < (const BigNumber &other) const {
    if(ncf < other.ncf) {
      return true;
    }
    if(ncf > other.ncf) {
      return false;
    }
    int i = 0;
    while(i < ncf && cf[i] == other.cf[i]) {
      i++;
    }
    return cf[i] < other.cf[i];
  }

  bool operator > (const BigNumber &other) const {
    if(ncf > other.ncf) {
      return true;
    }
    if(ncf < other.ncf) {
      return false;
    }
    int i = 0;
    while(i < ncf && cf[i] == other.cf[i]) {
      i++;
    }
    return cf[i] > other.cf[i];
  }
};

struct Query {
  BigNumber val;
  int idx;

  void operator = (const Query &other) {
    val = other.val;
    idx = other.idx;
  }

  bool operator < (const Query &other) const {
    return val < other.val;
  }
}; 

BigNumber comb[2][MAXN + 1], aux;
std::vector<Query> queries[MAXN + 1];
int answer[MAXM + 1];

int main() {
  ios_base::sync_with_stdio(0);
  cin.tie(0);

  int n, q;
  cin >> n >> q;
  for(int i = 1; i <= n; i++) {
    int val;
    cin >> val;
    fr[val]++;
  }

  for(int i = 1; i <= MAXVAL; i++) {
    fr[i] += fr[i - 1];
  }
  for(int i = 1; i <= q; i++) {
    int st, dr;
    cin >> st >> dr;
    int cnt = fr[dr] - fr[st - 1];

    aux.read();
    queries[cnt].push_back({aux, i});
  }
  
  for(int i = 0; i <= n; i++) {
    comb[i & 1][0].reset();
    for(int j = 1; j <= i / 2 + 1; j++) {
      comb[(i & 1) ^ 1][j - 1] += comb[(i & 1) ^ 1][j];
      comb[i & 1][j] = comb[(i & 1) ^ 1][j - 1];
    }

    sort(queries[i].begin(), queries[i].end());
    int ptr = 0;
    for(int j = 1; j <= i / 2; j++) {
      while(ptr < (int)queries[i].size() && !(queries[i][ptr].val > comb[i & 1][j])) {
        answer[queries[i][ptr++].idx] = j;
      }
    }
    while(ptr < (int)queries[i].size()) {
      answer[queries[i][ptr++].idx] = -1;
    }
  }

  for(int i = 1; i <= q; i++) {
    cout << answer[i] << "\n";
  }

  return 0;
}