#include <bits/stdc++.h>
using namespace std;

using ll = long long;
#define pb push_back
#define int ll

const int MAX_N = 3e3, MAX_PETALS = 1e5;

std::istream& operator>> (std::istream& inp, __int128& n) {
    std::string num;
    inp >> num ;
    n=0;
    bool negative=false;
    for (auto c : num) {
        n*=10;
        if (c=='-') negative=true;
        else n+=(c-'0');
    }
    if (negative==true) n*=(-1);
    return inp;
}

int p[MAX_N + 1];
// p[i] -> how many petals does the i-th flower have
int aib[MAX_PETALS + 1];

void update (int pos, int val) {
  for (int i = pos; i <= MAX_PETALS; i += (i & (-i))) {
    aib[i] += val;
  }
}

int query (int pos) {
  int ans = 0;
  for (int i = pos; i >= 1; i -= (i & (-i))) {
    ans += aib[i];
  }
  return ans;
}

__int128 comb (int n, int k) {
  __int128 top = __int128(1);

  for (int i = 1; i <= n; i++) {
    top *= __int128(i);
  }
  for (int i = 1; i <= k; i++) {
    top /= i;
  }
  for (int i = 1; i <= n - k; i++) {
    top /= i;
  }
  return top;
}

signed main () {
  ios_base::sync_with_stdio(false);
  cin.tie(nullptr);

  int n, m, i, l, r, num_flowers_total, num_flowers_bouquet;
  __int128 k;
  // string k; // k can be up to 10^900????

  cin >> n >> m;
  // n -> num types of different flowers
  // m -> num of orders

  for (i = 1; i <= n; i++) {
    cin >> p[i];
    update(p[i], 1);
  }

  for (i = 1; i <= m; i++) {
    cin >> l >> r >> k;
    // gotta make k different bouquets
    // all of them have to contain the same number of flowers
    // we can only use a flower i, if L <= p[i] <= R
    // a bouquet can't have multiple flowers of the same type
    num_flowers_total = query(r) - query(l - 1);
    for (num_flowers_bouquet = 1; num_flowers_bouquet <= num_flowers_total; num_flowers_bouquet++) {
      if (comb(num_flowers_total, num_flowers_bouquet) >= k) {
        break;
      }
    }
    if (num_flowers_bouquet == num_flowers_total + 1) {
      num_flowers_bouquet = -1;
    }
    cout << num_flowers_bouquet << "\n";
  }
  return 0;
}
