#include <bits/stdc++.h>
using namespace std;

using ll = long long;
#define pb push_back

const int MAX_NODE = 2e5;

struct DInfo {
  int mx_node, mx_dist;
  int mx_len, mx_u, mx_v;
};

vector<pair<int, int>> adj[MAX_NODE + 1];
int d[MAX_NODE + 1];
bool was_vis[MAX_NODE + 1];
set<pair<int, pair<int, int>>, greater<pair<int, pair<int, int>>>> edges;

DInfo get_max_dist_info (int start_node) {
  int curr_node, node, w, mx_dist, mx_node, mx_len, mx_u, mx_v;
  queue<int> bfs;

  for (node = 0; node <= MAX_NODE; node++) {
    d[node] = 0;
    was_vis[node] = false;
  }

  bfs.push(start_node);
  d[start_node] = 0;
  was_vis[start_node] = true;

  mx_dist = 0;
  mx_node = start_node;

  mx_len = 0;
  mx_u = start_node;
  mx_v = start_node;
  while (!bfs.empty()) {
    curr_node = bfs.front();
    bfs.pop();

    for (auto edge : adj[curr_node]) {
      tie(node, w) = edge;
      if (!was_vis[node]) {
        was_vis[node] = true;
        d[node] = d[curr_node] + w;
        if (d[node] > mx_dist) {
          mx_dist = d[node];
          mx_node = node;
        }
        if (w > mx_len) {
          mx_len = w;
          mx_u = curr_node;
          mx_v = node;
        }

        bfs.push(node);
      }
    }
  }

  return {mx_node, mx_dist, mx_len, mx_u, mx_v};
}

signed main () {
  ios_base::sync_with_stdio(false);
  cin.tie(nullptr);

  int n, k, i, u, v, w, mx_node, mx_dist, mx_len, mx_u, mx_v;
  DInfo info;

  cin >> n >> k;
  for (i = 1; i <= n - 1; i++) {
    cin >> u >> v >> w;
    adj[u].push_back(make_pair(v, w));
    adj[v].push_back(make_pair(u, w));
  }
  for (i = 1; i <= k; i++) {
    info = get_max_dist_info(1);
    info = get_max_dist_info(info.mx_node);

    auto it = find(adj[info.mx_u].begin(), adj[info.mx_u].end(), make_pair(info.mx_v, info.mx_len));
    adj[info.mx_u].erase(it);
    adj[info.mx_u].push_back(make_pair(info.mx_v, info.mx_len - 1));
  }

  info = get_max_dist_info(1);
  info = get_max_dist_info(info.mx_node);

  cout << info.mx_dist << "\n";
  return 0;
}
