#include <bits/stdc++.h>
using namespace std;

using ll = long long;
#define pb push_back

const int MAX_NODE = 2e5, MAX_W = 1e4;

struct DInfo {
  int mx_node, mx_dist;
  int mx_len, mx_u, mx_v;
};

struct LenInfo {
  int mx_len, mx_u, mx_v;
};

vector<pair<int, int>> adj[MAX_NODE + 1];
int d[MAX_NODE + 1];
bool was_vis[MAX_NODE + 1];
LenInfo li[MAX_NODE + 1];
int w_freq[MAX_W + 1];
set<pair<int, pair<int, int>>, greater<pair<int, pair<int, int>>>> edges;

DInfo get_max_dist_info (int start_node) {
  int curr_node, node, w, mx_dist, mx_node, mx_len, mx_u, mx_v;
  queue<int> bfs;

  for (node = 0; node <= MAX_NODE; node++) {
    d[node] = 0;
    was_vis[node] = false;
    li[node] = {0, start_node, start_node};
  }

  bfs.push(start_node);
  d[start_node] = 0;
  was_vis[start_node] = true;

  mx_dist = 0;
  mx_node = start_node;

  mx_len = 0;
  mx_u = start_node;
  mx_v = start_node;
  while (!bfs.empty()) {
    curr_node = bfs.front();
    bfs.pop();

    for (auto edge : adj[curr_node]) {
      tie(node, w) = edge;
      if (!was_vis[node]) {
        was_vis[node] = true;
        d[node] = d[curr_node] + w;
        if (d[node] > mx_dist) {
          mx_dist = d[node];
          mx_node = node;
        }
        li[node] = {w, curr_node, node};

        bfs.push(node);
      }
    }
  }

  return {mx_node, mx_dist, li[mx_node].mx_len, li[mx_node].mx_u, li[mx_node].mx_v};
}

signed main () {
  ios_base::sync_with_stdio(false);
  cin.tie(nullptr);

  int n, k, i, u, v, w, mx_node, mx_dist, mx_len, mx_u, mx_v;
  DInfo info;
  LenInfo linfo;

  cin >> n >> k;
  for (i = 1; i <= n - 1; i++) {
    cin >> u >> v >> w;
    adj[u].push_back(make_pair(v, w));
    adj[v].push_back(make_pair(u, w));
    w_freq[w]++;
  }
  for (i = 1; i <= k; i++) {
    info = get_max_dist_info(1);
    linfo = {info.mx_len, info.mx_u, info.mx_v};
    // cout << "\n";
    // cout << "currently the diameter is between " << info.mx_node << " and ";
    info = get_max_dist_info(info.mx_node);
    if (info.mx_len > linfo.mx_len) {
      linfo = {info.mx_len, info.mx_u, info.mx_v};
    }
    // cout << info.mx_node << "\n";
    // cout << "the max edge length (" << info.mx_len << ") is between " << info.mx_u << " and " << info.mx_v << "\n";

    auto it = find(adj[linfo.mx_u].begin(), adj[linfo.mx_u].end(), make_pair(linfo.mx_v, linfo.mx_len));
    adj[linfo.mx_u].erase(it);
    adj[linfo.mx_u].push_back(make_pair(linfo.mx_v, linfo.mx_len - 1));

    auto it2 = find(adj[linfo.mx_v].begin(), adj[linfo.mx_v].end(), make_pair(linfo.mx_u, linfo.mx_len));
    adj[linfo.mx_v].erase(it2);
    adj[linfo.mx_v].push_back(make_pair(linfo.mx_u, linfo.mx_len - 1));

    w_freq[linfo.mx_len]--;
    w_freq[linfo.mx_len - 1]++;

    // all of the lengths are 0
    // no point in going forward
    if (w_freq[0] == n - 1) {
      break;
    }
  }

  info = get_max_dist_info(1);
  info = get_max_dist_info(info.mx_node);

  cout << info.mx_dist << "\n";
  return 0;
}
