#include <bits/stdc++.h>
using namespace std;

using ll = long long;
#define pb push_back

const int MAX_NODE = 2e5;

vector<pair<int, int>> adj[MAX_NODE + 1];
int d[MAX_NODE + 1];
bool was_vis[MAX_NODE + 1];
set<pair<int, pair<int, int>>, greater<pair<int, pair<int, int>>>> edges;

pair<int, int> get_max_dist_node (int start_node) {
  int curr_node, node, w, mx_dist, mx_node;
  queue<int> bfs;

  for (node = 0; node <= MAX_NODE; node++) {
    d[node] = 0;
    was_vis[node] = false;
  }

  bfs.push(start_node);
  d[start_node] = 0;
  was_vis[start_node] = true;

  mx_dist = 0;
  mx_node = start_node;
  while (!bfs.empty()) {
    curr_node = bfs.front();
    bfs.pop();

    for (auto edge : adj[curr_node]) {
      tie(node, w) = edge;
      if (!was_vis[node]) {
        was_vis[node] = true;
        d[node] = d[curr_node] + w;
        if (d[node] > mx_dist) {
          mx_dist = d[node];
          mx_node = node;
        }

        bfs.push(node);
      }
    }
  }

  return make_pair(mx_node, mx_dist);
}

signed main () {
  ios_base::sync_with_stdio(false);
  cin.tie(nullptr);

  int n, k, i, u, v, w, node1, dist1, node2, dist2;

  cin >> n >> k;
  for (i = 1; i <= n - 1; i++) {
    cin >> u >> v >> w;
    edges.insert(make_pair(w, make_pair(u, v)));
  }
  for (i = 1; i <= k; i++) {
    auto top = *edges.begin();
    if (top.first == 0) {
      break;
    }

    top.first -= 1;

    edges.erase(edges.begin());
    edges.insert(top);
  }
  for (auto edge : edges) {
    w = edge.first;
    tie(u, v) = edge.second;
    adj[u].push_back(make_pair(v, w));
    adj[v].push_back(make_pair(u, w));
  }

  tie(node1, dist1) = get_max_dist_node(1);
  tie(node2, dist2) = get_max_dist_node(node1);

  cout << dist2 << "\n";
  return 0;
}
