#include <bits/stdc++.h>
using namespace std;

using ll = long long;
#define pb push_back

const int MAX_NODE = 2e5;

struct DInfo {
  int mx_node, mx_dist;
  vector<vector<pair<int, int>>> simple_paths;
};

vector<pair<int, int>> adj[MAX_NODE + 1];
int d[MAX_NODE + 1];
bool was_vis[MAX_NODE + 1];

vector<pair<int, int>> get_simple_path (int a, int b) {
  int curr_node, node, w;
  vector<int> curr_nodes;

  queue<pair<int, vector<int>>> bfs;

  vector<pair<int, int>> path;
  vector<int> nodes;
  nodes.push_back(a);

  for (node = 0; node <= MAX_NODE; node++) {
    was_vis[node] = false;
  }

  bfs.push(make_pair(a, nodes));
  was_vis[a] = true;
  while (!bfs.empty()) {
    tie(curr_node, curr_nodes) = bfs.front();
    bfs.pop();

    if (curr_node == b) {
      for (int i = 0; i < curr_nodes.size(); i++) {
        path.push_back(make_pair(curr_nodes[i], curr_nodes[i + 1]));
      }
      return path;
    }

    for (auto edge : adj[curr_node]) {
      tie(node, w) = edge;
      if (!was_vis[node]) {
        was_vis[node] = true;
        curr_nodes.push_back(node);
        bfs.push(make_pair(node, curr_nodes));
        curr_nodes.pop_back();
      }
    }
  }

  return path;
}

DInfo get_max_dist_info (int start_node) {
  int curr_node, node, w, mx_dist, mx_node;
  queue<int> bfs;

  for (node = 0; node <= MAX_NODE; node++) {
    d[node] = -1;
    was_vis[node] = false;
  }

  bfs.push(start_node);
  d[start_node] = 0;
  was_vis[start_node] = true;

  mx_dist = 0;
  mx_node = start_node;
  while (!bfs.empty()) {
    curr_node = bfs.front();
    bfs.pop();

    for (auto edge : adj[curr_node]) {
      tie(node, w) = edge;
      if (!was_vis[node]) {
        was_vis[node] = true;
        d[node] = d[curr_node] + w;
        if (d[node] > mx_dist) {
          mx_dist = d[node];
          mx_node = node;
        }

        bfs.push(node);
      }
    }
  }

  vector<vector<pair<int, int>>> paths;
  for (node = 0; node <= MAX_NODE; node++) {
    if (d[node] == mx_dist) {
      paths.push_back(get_simple_path(start_node, node));
    }
  }

  return {mx_node, mx_dist, paths};
}

signed main () {
  ios_base::sync_with_stdio(false);
  cin.tie(nullptr);

  int n, k, i, u, v, w, mx_node, mx_dist, mx_len, mx_u, mx_v;
  DInfo info;

  cin >> n >> k;
  map<pair<int, int>, int> to_weight;
  for (i = 1; i <= n - 1; i++) {
    cin >> u >> v >> w;
    adj[u].push_back(make_pair(v, w));
    to_weight[make_pair(u, v)] = w;
    adj[v].push_back(make_pair(u, w));
    to_weight[make_pair(v, u)] = w;
  }

  info = get_max_dist_info(1);
  info = get_max_dist_info(info.mx_node);

  map<pair<int, int>, int> freq;
  for (auto e1 : info.simple_paths) {
    for (auto e2 : e1) {
      freq[make_pair(min(e2.first, e2.second), max(e2.first, e2.second))]++;
    }
  }

  int mx_freq = 0;
  for (auto e : freq) {
    mx_freq = max(mx_freq, e.second);
    // cout << "(" << e.first.first << ", " << e.first.second << ") -> " << e.second << "\n";
  }

  pair<int, int> choose;
  for (auto e : freq) {
    if (e.second == mx_freq) {
      choose = e.first;
    }
  }

  auto it = find(adj[choose.first].begin(), adj[choose.first].end(), make_pair(choose.second, to_weight[choose]));
  adj[choose.first].erase(it);
  adj[choose.first].push_back(make_pair(choose.second, to_weight[choose] - 1));

  auto it2 = find(adj[choose.second].begin(), adj[choose.second].end(), make_pair(choose.first, to_weight[choose]));
  adj[choose.second].erase(it2);
  adj[choose.second].push_back(make_pair(choose.first, to_weight[choose] - 1));

  info = get_max_dist_info(1);
  info = get_max_dist_info(info.mx_node);

  cout << info.mx_dist << "\n";
  return 0;
}
