#include <bits/stdc++.h>

using namespace std;

#define MAXN 200000
#define INF 1000000000

int d[MAXN + 1];

struct Nod {
    int to, cost;
};

struct cmp {
    bool operator () ( Nod a, Nod b ) {
        return d[a.to] < d[b.to];
    }
};

priority_queue<Nod, vector<Nod>, cmp> pq;
vector<Nod> g[MAXN + 1];

void dijkstra( int start ) {
    Nod nod;
    pq.push( { start, 0 } );
    d[start] = 0;
    while( !pq.empty() ) {
        nod = pq.top();
        pq.pop();
        if( nod.cost < d[nod.to] )
            continue;
        for( Nod vec : g[nod.to] ) {
            if( d[vec.to] < d[nod.to] + vec.cost ) {
                d[vec.to] = d[nod.to] + vec.cost;
                pq.push( { vec.to, d[vec.to] } );
            }
        }
    }
}

int main() {
    int n, k, u, v, c, i, maxi;
    ios_base::sync_with_stdio( 0 );
    cin.tie( 0 );
    cout.tie( 0 );

    cin >> n >> k;
    for( i = 1; i <= n - 1; i++ ) {
        cin >> u >> v >> c;
        g[u].push_back( { v, c } );
    }

    fill( d + 1, d + n + 1, 0 );
    dijkstra( 1 );

    maxi = 0;
    for( i = 1; i <= n; i++ )
    {
        maxi = max( d[i], maxi );
    }
    cout << maxi;
    return 0;
}
