#include <stdio.h>

#define D 1

#define MAXN 200000

struct node{
  int adj;
};

struct edge{
  int cost;
  int next;
  int pointer;
};

int nrE;
struct node tree[MAXN+1];
struct edge edges[MAXN*2];

static inline void connect(int p, int c, int cost){
  edges[nrE].cost = cost;
  edges[nrE].pointer = c;
  edges[nrE].next = tree[p].adj;

  tree[p].adj = nrE;

  nrE++;
}

static inline void addEdge(int u, int v, int cost){
  connect(u, v, cost);
  connect(v, u, cost);
}

int farthestPoint, maxDist;
void DFSfarthestpoint(int u, int parent, int dist){
  if(dist > maxDist){
    farthestPoint = u;
    maxDist = dist;
  }

  for(int p = tree[u].adj; p; p = edges[p].next)
    if(edges[p].pointer != parent)
      DFSfarthestpoint(edges[p].pointer, u, dist + edges[p].cost);
}

int main(){
  int n, k, maxCost, i, a, b, cost;

  scanf("%d%d", &n, &k);
  maxCost = 0;
  nrE = 1;
  for(i = 0; i < n-1; i++){
    scanf("%d%d%d", &a, &b, &cost);
    if(cost > maxCost)
      maxCost = cost;
    addEdge(a, b, cost);
  }

  farthestPoint = maxDist = -1;
  DFSfarthestpoint(1, 0, 0);
  maxDist = -1;
  DFSfarthestpoint(farthestPoint, 0, 0);

  if(k == 0)
    printf("%d\n", maxDist);
  else if(k == 1)
    printf("%d\n", ((maxDist-1) > 0 ? (maxDist-1) : 0));
  else if(maxCost <= 1)
    printf("%d\n", maxDist > n-1-k ? n-1-k : maxDist);


  return 0;
}
/*
5 6
1 2 5
2 3 4
2 4 3
4 5 2

5 1
1 2 5
2 3 4
2 4 3
4 5 2

5 6
1 2 1
2 3 1
2 4 1
4 5 1
*/
