#include <stdio.h>

#define D 0

#define MAXN 200000

struct node{
  int adj;
};

struct edge{
  int cost;
  int next;
  int pointer;
};

int nrE;
struct node tree[MAXN+1];
struct edge edges[MAXN*2];
int dPoints[2];
int dDistance[2][MAXN+1];

static inline int max(int a, int b){
  return a > b ? a : b;
}

static inline void connect(int p, int c, int cost){
  edges[nrE].cost = cost;
  edges[nrE].pointer = c;
  edges[nrE].next = tree[p].adj;

  tree[p].adj = nrE;

  nrE++;
}

static inline void addEdge(int u, int v, int cost){
  connect(u, v, cost);
  connect(v, u, cost);
}

int farthestPoint, maxDist;
void DFSfarthestpoint(int u, int parent, int dist){
  if(dist > maxDist){
    farthestPoint = u;
    maxDist = dist;
  }

  for(int p = tree[u].adj; p; p = edges[p].next)
    if(edges[p].pointer != parent)
      DFSfarthestpoint(edges[p].pointer, u, dist + edges[p].cost);
}

int origin = 0;
void DFSdist(int u, int parent, int dist){
  dDistance[origin][u] = dist;

  for(int p = tree[u].adj; p; p = edges[p].next)
    if(edges[p].pointer != parent)
      DFSdist(edges[p].pointer, u, dist + edges[p].cost);

}

int main(){
  int n, k, maxCost, i, a, b, cost, totalCost, diameter;

  scanf("%d%d", &n, &k);
  maxCost = totalCost = 0;
  nrE = 1;
  for(i = 0; i < n-1; i++){
    scanf("%d%d%d", &a, &b, &cost);
    if(cost > maxCost)
      maxCost = cost;
    addEdge(a, b, cost);
    totalCost += cost;
  }

  farthestPoint = maxDist = -1;
  DFSfarthestpoint(1, 0, 0);
  dPoints[0] = farthestPoint;

  maxDist = -1;
  DFSfarthestpoint(farthestPoint, 0, 0);
  dPoints[1] = farthestPoint;


  if(k == 0){
    printf("%d\n", maxDist);
  }else if(k == 1){
    diameter = maxDist;

    origin = 0;
    DFSdist(dPoints[0], 0, 0);

    origin = 1;
    DFSdist(dPoints[1], 0, 0);

    if(D){
      printf("%d %d\n", dPoints[0], dPoints[1]);
      for(i = 1; i <= n; i++)
        printf("%d: %d %d\n", i, dDistance[0][i], dDistance[1][i]);
    }

    i = 1;
    while(i <= n && (max(dDistance[0][i], dDistance[1][i]) < diameter || i == dPoints[0] || i == dPoints[1]))
      i++;

    if(i == n+1)
      printf("%d\n", diameter);
    else
      printf("%d\n", diameter-1);
  }else if(maxCost <= 1){
    diameter = maxDist;

    origin = 0;
    DFSdist(dPoints[0], 0, 0);

    origin = 1;
    DFSdist(dPoints[1], 0, 0);


  }


  return 0;
}
/*
5 6
1 2 5
2 3 4
2 4 3
4 5 2

5 1
1 2 5
2 3 4
2 4 3
4 5 2

5 6
1 2 1
2 3 1
2 4 1
4 5 1
*/
