#include <bits/stdc++.h>
using namespace std;
using ull = unsigned long long;

constexpr ull BTS = 63;
constexpr ull MSK = (1ULL << BTS) - 1;

struct BigInt {
    vector<ull> a;
    BigInt() {}
    BigInt(ull n) {
        a.push_back(n);
    }
    BigInt operator+(const BigInt &o) const {
        if (a.size() >= 52) {
            return *this;
        }
        if (o.a.size() >= 52) {
            return o;
        }
        BigInt b;
        int mem = 0;
        for (int i = 0; i < max(a.size(), o.a.size()); ++i) {
            ull val = mem + (i < a.size() ? a[i] : 0ULL) + (i < o.a.size() ? o.a[i] : 0ULL);
            b.a.push_back(val & MSK);
            mem = val >> BTS;
        }
        if (mem) {
            b.a.push_back(mem);
        }
        return b;
    }
    bool operator<(const BigInt &o) const {
        if (o.a.empty()) {
            return false;
        }
        if (a.empty()) {
            return true;
        }
        assert(o.a.back() && a.back());
        if (a.size() < o.a.size()) {
            return true;
        }
        for (int i = (int) a.size() - 1; i >= 0; --i) {
            if (a[i] < o.a[i]) {
                return true;
            } else if (a[i] > o.a[i]) {
                return false;
            }
        }
        return false;
    }
};

int main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    int n, m;
    cin >> n >> m;
    vector<int> a(n);
    for (int i = 0; i < n; ++i) {
        // a[i] = 1;
        cin >> a[i];
    }
    vector<vector<BigInt>> dp(n + 1);
    dp[0].resize(1, 1);
    auto getItem = [&](int i, int j) {
        if (j > i) {
            return BigInt{0};
        } else if (j <= (i + 1) / 2) {
            return dp[i][j];
        } else {
            return dp[i][i - j];
        }
    };
    for (int i = 1; i <= n; ++i) {
        dp[i].resize((i + 1) / 2 + 1);
        dp[i][0] = 1;
        for (int j = 1; j <= (i + 1) / 2; ++j) {
            dp[i][j] = getItem(i - 1, j - 1) + getItem(i - 1, j);
        }
    }
    vector<int> nmb(100'001);
    for (int i = 0; i < n; ++i) {
        nmb[a[i]]++;
    }
    for (int i = 1; i <= 100'000; ++i) {
        nmb[i] += nmb[i - 1];
    }
    for (int q = 0; q < m; ++q) {
        int ql, qr;
        string K;
        cin >> ql >> qr >> K;
        BigInt k;
        for (char c : K) {
            BigInt k1 = k;
            BigInt k2 = k1 + k1;
            BigInt k4 = k2 + k2;
            BigInt k5 = k4 + k1;
            k = k5 + k5 + BigInt{c - '0'};
        }
        int nn = nmb[qr] - nmb[ql - 1];
        auto it = lower_bound(dp[nn].begin() + 1, dp[nn].begin() + (nn + 1) / 2 + 1, k);
        if (it == dp[nn].begin() + (nn + 1) / 2 + 1) {
            cout << "-1\n";
        } else {
            cout << it - dp[nn].begin() << "\n";
        }
    }
}