#include <bits/stdc++.h>
using namespace std;
using ll = long long;
//const ll INF = 1e18 + 7;
const ll MAXC = 1e3;

struct Int {
    vector<ll> r;

    bool operator == (const Int &o) const {
        return (r == o.r);
    }

    bool operator <= (const Int &o) const {
        if (r.size() != o.r.size()) {
            return r.size() < o.r.size();
        }
        for (ll i = (ll)r.size() - 1; i >= 0; i--) {
            if (r[i] != o.r[i]) {
                return r[i] < o.r[i];
            }
        }
        return true;
    }

    bool operator < (const Int &o) const {
        if (r.size() != o.r.size()) {
            return r.size() < o.r.size();
        }
        for (ll i = (ll)r.size() - 1; i >= 0; i--) {
            if (r[i] != o.r[i]) {
                return r[i] < o.r[i];
            }
        }
        return false;
    }

    Int operator + (const Int &o) const {
        ll sz1 = r.size();
        ll sz2 = o.r.size();
        ll mx = max(sz1, sz2);

        ll car = 0;
        vector<ll> ret(mx);
        for (ll i = 0; i < mx; i++) {
            ll w = car;
            if (i < sz1) w += r[i];
            if (i < sz2) w += o.r[i];
            ret[i] = w % 10;
            car = w / 10;
        }
        if (car) {
            ret.push_back(car);
        }

        return Int(ret);
    }

    Int(const string &_r) {
        r = {};
        for (auto &c : _r) {
            r.push_back(c - '0');
        }
    }
    Int(const vector<ll> &_r) {
        r = _r;
    }
    Int() {
        r = {0};
    }
};


void solve() {
    ll n, q;
    cin >> n >> q;
    vector<ll> a(n);
    for (auto &el : a) {
        cin >> el;
    }
    sort(a.begin(), a.end());

    //C[n][k]
    vector<vector<Int>> dp(n + 1, vector<Int> (n + 1));
    for (ll i = 0; i <= n; i++) {
        dp[i][0] = Int("1");
    }
    Int INF = Int("0");
    for (ll i = 0; i < MAXC - 2; i++) {
        INF.r.push_back(0);
    }
    INF.r.push_back(1);
    for (ll i = 1; i <= n; i++) {
        for (ll j = 1; j <= i; j++) {
            if ((ll)dp[i - 1][j].r.size() >= MAXC || (ll)dp[i - 1][j - 1].r.size() >= MAXC) {
                dp[i][j] = INF;
                continue;
            }
            dp[i][j] = (dp[i - 1][j] + dp[i - 1][j - 1]);
            if ((ll)dp[i][j].r.size() >= MAXC) {
                dp[i][j] = INF;
            }
        }
    }

    vector<vector<Int>> rm(n + 1);
    for (ll i = 0; i <= n; i++) {
        for (ll j = 0; j <= i / 2; j++) {
            rm[i].push_back(dp[i][j]);
        }
    }

    while (q--) {
        ll l, r;
        string kk;
        cin >> l >> r >> kk;
        Int k = Int(kk);
        ll cn = upper_bound(a.begin(), a.end(), r) - lower_bound(a.begin(), a.end(), l);
        if (k == Int("1")) {
            cout << (cn > 0 ? 1 : -1) << '\n';
            continue;
        }

        ll id = lower_bound(rm[cn].begin(), rm[cn].end(), k) - rm[cn].begin();
        cout << (id == (ll)rm[cn].size() ? -1 : id) << '\n';
    }
}


int main() {
    bool IS_MULTITEST = 0;
    #ifdef flam3
        IS_MULTITEST = 1;
        freopen("ain.txt", "r", stdin);
    #endif
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    ll t = 1;
    if (IS_MULTITEST) {
        cin >> t;
    }
    while (t--) {
        solve();
    }
}