#include<iostream>
#include<vector>
#include<algorithm>
#include<cmath>
#include<string>
#include<functional>
#include<numeric>

using namespace std;

#define int long long
#define all(a) a.begin(), a.end()
#define cin(a) for(auto &now : a) cin >> now;
#define print(a, s) for(auto now : a) cout << now << s;
#define chmin(a, b) a = min(a, b)
#define chmax(a, b) a= max(a, b)
const int M = 1e18;
int st[19];
void precalc() {
	st[0] = 1;
	for (int i = 1; i < 19; ++i) st[i] = st[i - 1] * 10;
}
struct Int {
	vector<int> v;
	Int() : v({ 0 }) {}
	Int(vector<int> v) : v(v) {}
	Int(string s) {
		reverse(all(s));
		v.resize((s.size() + 17) / 18);
		for (int i = 0; i < s.size(); ++i) {
			v[i / 18] += st[i % 18] * (s[i] - '0');
		}
	}
	Int operator+(const Int other) const {
		Int res; res.v.pop_back(); res.v.reserve(max(v.size(), other.v.size()));
		int add = 0;
		for (int i = 0; i <= max(v.size(), other.v.size()); ++i) {
			int k = (i < v.size() ? v[i] : 0) + (i < other.v.size() ? other.v[i] : 0) + add;
			if (k == 0) break;
			res.v.push_back(k % M);
			add = k / M;
		}
		return res;
	}
	bool operator<(const Int other) {
		if (v.size() != other.v.size()) return v.size() < other.v.size();
		else {
			for (int i = v.size() - 1; i >= 0; --i) {
				if (v[i] != other.v[i]) {
					return v[i] < other.v[i];
				}
			}
			return 0;
		}
	}
};
bool comp(tuple<int, Int, int, int, int> a, tuple<int, Int, int, int, int> b) {
	if (get<0>(a) == get<0>(b)) return get<1>(a) < get<1>(b);
	else return get<0>(a) < get<0>(b);
}
void solve() {
	int n, m; cin >> n >> m;
	vector<int> a(n); cin(a);
	sort(all(a));
	vector < tuple<int, Int, int, int, int>> qs(m);
	vector<int> ans(m, -1);
	for (int i = 0; i < m; ++i) {
		int li, ri; cin >> li >> ri;
		string s; cin >> s;
		Int k(s);
		int cnt = (upper_bound(all(a), ri) - a.begin()) - (lower_bound(all(a), li) - a.begin());
		qs[i] = { cnt, k, li, ri, i};
	}
	sort(all(qs), comp);
	int tk = 0;
	vector<Int> C0(n + 1), C1(n + 1);C0[0] = Int(vector<int>{ 1 });
	for (int i = 1; i <= n; ++i) {
		for (int k = 0; k <= i; ++k) {
			if (k == 0 || k == i) C1[k] = Int(vector<int>{ 1 });
			else C1[k] = C0[k - 1] + C0[k];
		}
		int j = 0;
		for (; tk < m; ++tk) {
			auto [cnt, k, li, ri, ind] = qs[tk];
			if (cnt > i) break;
			for (; j <= (i + 1) / 2; ++j) {
				if (!(C1[j] < k)) {
					ans[ind] = j;
					break;
				}
			}
		}
		if (tk == m) break;
		swap(C0, C1);
	}
	print(ans, "\n");
}

int32_t main() {
	ios::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);

	precalc();

	int t = 1;
	//cin >> t;
	while (t--) {
		solve();
	}
}