#include<algorithm>
#include<iostream>
#include<vector>
using namespace std;
const unsigned long long MX = 1000000000000000000;


struct BIG {
    vector<unsigned long long> all;
    BIG() : all({}) {}
    BIG(unsigned long long n) : all({n}) {} 
    BIG(vector<unsigned long long> all) : all(all) {} 
    BIG(string s) {
        __int128 now = 0, st = 1;
        for (long long i = -1 + s.size(); i >= 0; i--) {
            if (all.size() > (s.size() - i - 1) / 17) {
                st *= 10;
                all.back() += (s[i] - '0') * st;
            } else {
                st = 1;
                all.push_back(s[i] - '0');
            }
        }
        for (auto &i : all) {
            if (i > MX) {
                throw(0);
            }
        }
    }
    unsigned long long get(long long a) {
        if (all.size() <= a) {
            return 0;
        }
        return all[a];
    }
    BIG operator+(BIG other) {
        vector<unsigned long long> ans;
        long long add = 0;
        for (long long i = 0; i < max(all.size(), other.all.size()); i++) {
            if ((__int128)get(i) + add + other.get(i) >= MX) {
                ans.push_back((__int128) get(i) + other.get(i) + add - MX);
                add = 1;
            } else {
                ans.push_back((__int128) get(i) + other.get(i) + add);
                add = 0;
            }
        }
        if (add == 1) {
            ans.push_back(1);
        }
        return ans;
    }
    bool operator>=(BIG other) {
        if (other.all.size() < all.size()) {
            return true;
        }
        if (other.all.size() > all.size()) {
            return false;
        }
        for (long long i = -1 + all.size(); i >= 0; i--) {
            if (other.all[i] > all[i]) {
                return false;
            }
            if (other.all[i] < all[i]) {
                return true;
            }
        }
        return true;
    }
};

vector<vector<BIG>> all_C;

BIG C(long long n, long long k) {
    //cout << n << " " << k << endl;
    if (all_C[n][k].all.size() != 0) {
        return all_C[n][k];
    }
    if (n == k || k == 0) {
        all_C[n][k].all = {1ull};
        return all_C[n][k];
    }
    all_C[n][k].all = (C(n - 1, k - 1) + C(n - 1, k)).all;
    return all_C[n][k];
}


int main() {
    long long n, m;
    cin >> n >> m;
    // for (auto &i : BIG("999989999899998999989999899998").all) {
    //     cout << i << " ";
    // }
    // cout << endl;
    all_C.resize(n + 1, vector<BIG> (n + 1));
    //C(3000, 1500);
    vector<long long> a(n);
    for (auto &i : a) {
        cin >> i;
    }
    sort(a.begin(), a.end());
    while (m--) {
        long long l, r;
        cin >> l >> r;
        l = lower_bound(a.begin(), a.end(), l) - a.begin();
        r = upper_bound(a.begin(), a.end(), r) - a.begin() - 1;
        string k2;
        cin >> k2;
        BIG k(k2);
        long long L = 0, R = (r - l + 1 + 1) / 2;
        while (R - L > 1) {
            long long mid = (L + R) / 2;
            if (C(r - l + 1, mid) >= k) {
                R = mid;
            } else {
                L = mid;
            }
        }
        if (C(r - l + 1, R) >= k) {
            cout << R << endl;
        } else {
            cout << -1 << endl;
        }
    }
}