#include <stdio.h>
#include <vector>

const int MAX_N = 200'000;

struct Edge {
  int node, w;
};

int diam;
std::vector<Edge> adj[MAX_N];

int dfs(int node, int prev) {
  int max = 0;
  int max2 = 0;
  for(Edge e : adj[node]) {
    int v = e.node;
    int w = e.w;
    if(v != prev) {
      int x = w + dfs(v, node);
      if(x >= max) {
        max2 = max;
        max = x;
      } else if(x > max2) {
        max2 = x;
      }
    }
  }
  if(max + max2 > diam) {
    diam = max + max2;
  }
  return max;
}

int main() {
  int n, k;
  scanf("%d%d", &n, &k);
  for(int i = 0; i < n - 1; i++) {
    int u, v, w;
    scanf("%d%d%d", &u, &v, &w);
    adj[u - 1].push_back({v - 1, w});
    adj[v - 1].push_back({u - 1, w});
  }

  diam = -1;
  dfs(0, -1);
  printf("%d\n", diam);

  return 0;
}