#include <stdio.h>
#include "monopoly2.h"

using Edges = std::vector<std::pair<int, int>>;
Edges ret;

void solve(std::vector<int> active, std::vector<int> not_active, int level) {
  if(level == 25) {
    for(int i = 1; i < (int)active.size(); i++) {
      ret.push_back({active[0], active[i]});
    }
    return;
  }
  if((int)active.size() == 1) {
    return;
  }
  if((int)active.size() == 2) {
    ret.push_back({active[0], active[1]});
    return;
  }
  // active[0] este radacina subarborelui
  // si stim sigur ca exista muchia active[0]->active[1]
  ret.push_back({active[0], active[1]});
  // acum pun intrebarea active[1], active[2], ..., active[last], active[0]
  std::vector<int> query;
  for(int x : not_active) {
    query.push_back(x);
  }
  query.push_back(active[0]);
  for(int i = 2; i < (int)active.size(); i++) {
    query.push_back(active[i]);
  }
  query.push_back(active[1]);

  std::vector<int> not_active1, not_active2;
  std::vector<bool> ans = check(query);
  std::vector<int> active1;
  active1.push_back(active[1]);
  std::vector<int> active2;
  active2.push_back(active[0]);

  for(int x : not_active) {
    not_active1.push_back(x);
    not_active2.push_back(x);
  }
  not_active2.push_back(active[1]);
  not_active1.push_back(active[0]);

  for(int i = 1; i < (int)active.size() - 1; i++) {
    int j = i + (int)not_active.size();
    if(ans[j] == 1) {
      active1.push_back(query[j]);
      not_active2.push_back(query[j]);
    } else {
      active2.push_back(query[j]);
      not_active1.push_back(query[j]);
    }
  }

  solve(active2, not_active2, level);
  solve(active1, not_active1, level + 1);
}

Edges find_connections(int n) {
  ret.clear();
  std::vector<int> active;
  for(int i = 1; i <= n; i++) {
    active.push_back(i);
  }
  solve(active, {}, 1);
  return ret;
}