#include <stdio.h>
#include <vector>
#include <algorithm>
#define MAXN 200000

struct Node{
    std::vector <int> edges;
    std::vector <int> children;
    std::vector <int> cost;
    std::vector <int> c;
    int maxDif;
};

Node v[MAXN];
int maxTotal,maxX,maxY,ramase;

int dfs(int node, int parent){
    int max=0,x,special;
    v[node].maxDif=0;
    for(int i=0; i < (int)v[node].children.size(); i++){
        if(v[node].children[i]!=parent){
            x=dfs(v[node].children[i], node)+ v[node].cost[i];
            v[node].maxDif=std::max(v[node].maxDif, max+x);
            if(v[node].maxDif>maxTotal){
                maxTotal=v[node].maxDif;
                maxX=node;
                if(max<x)
                    maxY=v[node].children[i];
                else
                    maxY=special;
            }
            if(x>max){
                special=v[node].children[i];
                max=x;
            }
        }
    }
    return max;
}

void dfs1(int node, int parent){
    for(int i=0; i < (int)v[node].edges.size(); i++){
        if(v[node].edges[i]!=parent){
            v[node].children.push_back(v[node].edges[i]);
            v[node].cost.push_back(v[node].c[i]);
            dfs1(v[node].edges[i], node);
        }
    }
}

void merge(int x, int y){
    ramase--;
    int g=(int)v[x].children.size();
    for(int a = 0; a < (int)v[x].children.size(); a++){
        if(v[x].children[a]==y){
            v[x].children[a]=v[x].children[g-1];
            v[x].cost[a]=v[x].cost[g-1];
            v[x].children.pop_back();
            v[x].cost.pop_back();
        }
    }
    g=(int)v[x].children.size();
    g=(int)v[y].children.size();
    for(int a = 0; a < g; a++){
        if(v[y].children[a]!=x){
            v[x].children.push_back(v[y].children[a]);
            v[x].cost.push_back(v[y].cost[a]);
        }
    }
    v[y].children.clear();
    v[y].children.shrink_to_fit();
    v[y].cost.clear();
    v[y].cost.shrink_to_fit();
}

int main()
{
    int n,k,i,x,y,w;
    scanf("%d%d", &n, &k);
    for(i=1; i<n; i++){
        scanf("%d%d%d", &x, &y, &w);
        x--;y--;
        v[x].edges.push_back(y);
        v[y].edges.push_back(x);
        v[x].c.push_back(w);
        v[y].c.push_back(w);
    }
    dfs1(0, -1);
    ramase=n;
    for(i=0; ramase>=2 && i<k; i++){
        maxTotal=0;
        maxX=maxY=1;
        dfs(0, -1);
        for(int j=0; j<(int)v[maxX].children.size(); j++){
            if(v[maxX].children[j]==maxY){
                v[maxX].cost[j]--;
                if(v[maxX].cost[j]==0){
                    merge(maxX, maxY);
                }
                break;
            }
        }
    }
    dfs(0, -1);
    printf("%d", maxTotal);
    return 0;
}
