#include <bits/stdc++.h>
#define all(A) A.begin(), A.end()
using namespace std;

const int MAXA = 1e5;
const int MAXN = 1e3;

int pref[MAXA + 5];
string fact[MAXN + 5];

bool comp(string a, string b) {
    if (a.size() != b.size()) return a.size() > b.size();
    return a >= b;
}

string mul(string a, string b) {
    reverse(all(a)); reverse(all(b));
    vector <int> ret(a.size() + b.size() + 1, 0);
    for (int i = 0; i < a.size(); i++) {
        int carry = 0;
        for (int j = 0; j < b.size(); j++) {
            int cur = (a[i] - '0') * (b[j] - '0') + carry;
            ret[i + j] += (cur % 10);
            carry = cur / 10;
        }
        if (carry) ret[b.size() + i] += carry;
    }
    while (ret.back() == 0) ret.pop_back();
    string ans;
    int carry = 0;
    for (int i = 0; i < ret.size(); i++) {
        ret[i] += carry;
        ans.push_back((ret[i] % 10) + '0');
        carry = ret[i] / 10;
    }
    if (carry) ans.push_back(carry + '0');
    reverse(all(ans));
    return ans;
}

string sub(string a, string b) {
    reverse(all(a));
    reverse(all(b));
    while (b.size() < a.size()) b.push_back('0');
    string ret;
    int carry = 0;
    for (int i = 0; i < a.size(); i++) {
        int ca = a[i] - '0' + carry;
        int cur = ca - (b[i] - '0');
        if (cur < 0) {
            carry = -1;
            ret.push_back(cur + 10 + '0');
        }
        else {
            carry = 0;
            ret.push_back(cur + '0');
        }
    }
    while (ret.back() == '0') ret.pop_back();
    reverse (all(ret));
    return ret;
}

string div(string a, string b) {
    string ret;
    string cur;
    for (int i = 0; i < a.size(); i++) {
        cur.push_back(a[i]);
        int br = 0;
        while (comp (cur, b)) {
            cur = sub(cur, b);
            br++;
        }
        ret.push_back(br + '0');
        if (cur.size() == 1 && cur[0] == '0') cur.pop_back();
        if (ret.size() == 1 && ret[0] == '0') ret.pop_back();
    }
    return ret;
}

string itos (int a) {
    string ret;
    while (a) {
        int cur = a % 10;
        a /= 10;
        ret.push_back(cur + '0');
    }
    reverse (all(ret));
    return ret;
}

void calcfact(int n) {
    fact[0] = fact[1] = "1";
    for (int i = 2; i <= n; i++) {
        fact[i] = mul(fact[i - 1], itos(i));
    }
}

string calc_diff_comb(int n, int sz) {
    return div(fact[n], mul(fact[n - sz], fact[sz]));
}

int main() {
    int n, m; cin >> n >> m;
    calcfact(n);
    vector <int> v(n);
    for (auto &x : v) {
        cin >> x;
        pref[x]++;
    }
    for (int i = 1; i <= MAXA; i++) {
        pref[i] += pref[i - 1];
    }
    for (int i = 0; i < m; i++) {
        int l, r; cin >> l >> r;
        string k; cin >> k;
        int ans = 0;
        int n1 = pref[r] - pref[l - 1];
        bool f = false;
        for (int i = 1; i <= n1; i++) {
            if (comp(calc_diff_comb(n1, i), k)) {
                ans = i;
                f = true;
                break;
            }
        }
        if (f) {
            cout << ans << endl;
        }
        else cout << -1 << endl;
    }
}
