#include <iostream>
#include <vector>
#include <queue>
#define endl '\n'
using namespace std;
struct edge {
    long long ver, dist;
    edge(long long _v, long long _d) {ver=_v, dist=_d;}
    edge(){}
    ~edge(){}
    const bool operator<(const edge &a) const {
        return dist<a.dist;
    }
};
long long dist[300000];
vector<edge> v[300000];
void dijkstra(long long i) {
    priority_queue<edge> q;
    q.push({i,0});
    while(!q.empty()) {
        edge w = q.top(); q.pop();
        for(auto x : v[w.ver]) {
            if(dist[x.ver]>dist[w.ver]+x.dist) {
                dist[x.ver]=dist[w.ver]+x.dist;
                edge z = x;
                z.dist += dist[w.ver];
                q.push(z);
            }
        }
    }
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    long long n,k;
    cin >> n >> k;
    for(long long i = 0; i < n-1; i++) {
        long long a,b,w; cin >> a >> b >> w;
        v[a].push_back({b,w});
        v[b].push_back({a,w});
    }
    for(long long j = 1; j <= n; j++) dist[j]=2000000000;
    dist[1]=0;
    dijkstra(1);
    long long mx = 0, mxd=0;
    for(long long i = 2; i <= n; i++) if(dist[i]>mxd) {mxd = dist[i]; mx=i;}
    for(long long j = 1; j <= n; j++) dist[j]=2000000000;
    dist[mx]=0;
    dijkstra(mx);
    long long dm = 0;
    for(long long i = 1; i <= n; i++) {
        if(dist[i]>dm && i!=mx) dm=dist[i];
    }
    cout << dm;
}