#include <bits/stdc++.h>
using namespace std;

const long long MAXN = 3e3 + 10, MAXM = 1e5 + 10;
long long a[MAXN];
long long pascal[MAXN][MAXN];

long long solve(long long n, long long k) {
    if (n == 0) return -1;
    long long l = 1, r = (n + 1) / 2, ans = -1;

    while (l <= r) {
        long long m = (l + r) / 2;

        if (pascal[n][m] >= k) {
            ans = m;
            r = m - 1;
        } else l = m + 1;
    }

    return ans;
}

int main() {

    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    for (long long i = 0; i < MAXN; i++) pascal[i][0] = 1;

    for (long long i = 1; i < MAXN; i++) {
        for (long long j = 1; j <= i; j++) {
            pascal[i][j] = pascal[i - 1][j] + pascal[i - 1][j - 1];
        }
    }

    long long n, m;
    cin >> n >> m;

    for (long long i = 1; i <= n; i++) {
        cin >> a[i];
    }

    sort(a + 1, a + n + 1);

    for (long long i = 1; i <= m; i++) {
        long long l, r, k;
        cin >> l >> r >> k;

        long long cnt = upper_bound(a + 1, a + n + 1, r) - lower_bound(a + 1, a + n + 1, l);
        cout << solve(cnt, k) << '\n';
    }

    return 0;

}
/**
5 10
1 2 3 4 5
1 5 5
1 5 4
1 4 3
1 3 2
1 2 1

1 1 1
1 1 1
1 1 1
1 1 1
1 1 1
*/
