#include <bits/stdc++.h>
using namespace std;

vector <int> operator+(vector <int>& a, vector <int>& b) {
    vector <int> ans;
    int prenos = 0;

    for (int i = 0; i < max(a.size(), b.size()) || prenos; i++) {
        int sum = prenos;

        if (i < a.size()) sum += a[i];
        if (i < b.size()) sum += b[i];

        prenos = sum / 10;
        ans.push_back(sum % 10);
    }

    return ans;
}

bool operator>=(vector <int>& a, vector <int>& b) {
    if (a.size() != b.size()) return a.size() > b.size();

    for (int i = a.size() - 1; i >= 0; i--) {
        if (a[i] != b[i]) return a[i] > b[i];
    }

    return 1;
}
#include <bits/stdc++.h>
using namespace std;

class Number{
    long long BASE = 1e18;
public:
    vector <long long> num;

    Number() : num() {}
    Number(long long n) : num(1, n) {}

    Number(string& s) {
        while (s.size() >= 18) {
            num.push_back(0);

            for (long long i = 0, p = 1; i < 18; i++, p *= 10) {
                num.back() += p * (s.back() - '0');
                s.pop_back();
            }
        }

        num.push_back(0);

        for (long long i = 0, p = 1; !num.empty(); i++, p *= 10) {
            num.back() += p * (s.back() - '0');
            s.pop_back();
        }

        //while (num.size() && num.back() == 0) num.pop_back();
    }

    Number operator+(Number& n) {
        Number ans;
        long long prenos = 0;

        for (int i = 0; i < max(num.size(), n.num.size()) || prenos; i++) {
            long long sum = prenos;
            if (i < num.size()) sum += num[i];
            if (i < n.num.size()) sum += n.num[i];
            prenos = sum / BASE;

            ans.num.push_back(sum % BASE);
        }

        while (num.size() && num.back() == 0) num.pop_back();
        return ans;
    }

    bool operator>=(Number& n) {
        if (num.size() != n.num.size()) return num.size() > n.num.size();
        for (int i = num.size() - 1; i >= 0; i--) {
            if (num[i] != n.num[i]) return num[i] > n.num[i];
        }

        return 1;
    }
};

const long long MAXN = 100 + 10, MAXM = 1e5 + 10;
long long a[MAXN];
vector <int> pascal[MAXN][MAXN];

long long solve(long long n, vector <int>& k) {
    if (n == 0) return -1;
    long long l = 1, r = (n + 1) / 2, ans = -1;

    while (l <= r) {
        long long m = (l + r) / 2;

        if (pascal[n][m] >= k) {
            ans = m;
            r = m - 1;
        } else l = m + 1;
    }

    return ans;
}

int main() {

    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    for (long long i = 0; i < MAXN; i++) pascal[i][0] = vector <int> (1, 1);

    for (long long i = 1; i < MAXN; i++) {
        for (long long j = 1; j <= i; j++) {
            pascal[i][j] = pascal[i - 1][j] + pascal[i - 1][j - 1];
        }
    }

    long long n, m;
    cin >> n >> m;

    for (long long i = 1; i <= n; i++) {
        cin >> a[i];
    }

    sort(a + 1, a + n + 1);

    for (long long i = 1; i <= m; i++) {
        long long l, r;
        cin >> l >> r;
        string s;
        cin >> s;

        vector <int> k;

        while (s.size()) {
            k.push_back(s.back() - '0');
            s.pop_back();
        }

        long long cnt = upper_bound(a + 1, a + n + 1, r) - lower_bound(a + 1, a + n + 1, l);
        cout << solve(cnt, k) << '\n';
    }

    return 0;

}

