#include <bits/stdc++.h>
using namespace std;

unsigned long long BASE = 1e19;

vector <unsigned long long> operator+(vector <unsigned long long>& a, vector <unsigned long long>& b) {
    vector <unsigned long long> ans;
    unsigned long long prenos = 0;

    for (unsigned long long i = 0; i < max(a.size(), b.size()) || prenos; i++) {
        unsigned long long sum = prenos;

        if (i < a.size()) sum += a[i];
        if (i < b.size()) sum += b[i];

        prenos = sum / BASE;
        ans.push_back(sum % BASE);
    }

    return ans;
}

bool operator>=(vector <unsigned long long>& a, vector <unsigned long long>& b) {
    if (a.size() != b.size()) return a.size() > b.size();

    for (unsigned long long i = a.size() - 1; i >= 0; i--) {
        if (a[i] != b[i]) return a[i] > b[i];
    }

    return 1;
}

unsigned long long powers[30];

vector <unsigned long long> transform_to_number(string& s) {
    vector <unsigned long long> ans(1);

    int i = 0, br = 0;



    while (s.size()) {
        unsigned long long digit = s.back() - '0';
        s.pop_back();

        ans.back() += powers[i] * digit;

        i++;
        if (i == 19) {
            ans.push_back(0);
            i = 0;
        }
    }

    return ans;
}

#include <bits/stdc++.h>
using namespace std;

class Number{
    unsigned long long BASE = 1e18;
public:
    vector <unsigned long long> num;

    Number() : num() {}
    Number(unsigned long long n) : num(1, n) {}

    Number(string& s) {
        while (s.size() >= 18) {
            num.push_back(0);

            for (unsigned long long i = 0, p = 1; i < 18; i++, p *= 10) {
                num.back() += p * (s.back() - '0');
                s.pop_back();
            }
        }

        num.push_back(0);

        for (unsigned long long i = 0, p = 1; !num.empty(); i++, p *= 10) {
            num.back() += p * (s.back() - '0');
            s.pop_back();
        }

        //while (num.size() && num.back() == 0) num.pop_back();
    }

    Number operator+(Number& n) {
        Number ans;
        unsigned long long prenos = 0;

        for (unsigned long long i = 0; i < max(num.size(), n.num.size()) || prenos; i++) {
            unsigned long long sum = prenos;
            if (i < num.size()) sum += num[i];
            if (i < n.num.size()) sum += n.num[i];
            prenos = sum / BASE;

            ans.num.push_back(sum % BASE);
        }

        while (num.size() && num.back() == 0) num.pop_back();
        return ans;
    }

    bool operator>=(Number& n) {
        if (num.size() != n.num.size()) return num.size() > n.num.size();
        for (unsigned long long i = num.size() - 1; i >= 0; i--) {
            if (num[i] != n.num[i]) return num[i] > n.num[i];
        }

        return 1;
    }
};

const unsigned long long MAXN = 1500 + 10, MAXM = 1e5 + 10;
unsigned long long a[MAXN];
vector <unsigned long long> pascal[MAXN][MAXN];

unsigned long long solve(unsigned long long n, vector <unsigned long long>& k) {
    if (n == 0) return -1;
    unsigned long long l = 1, r = (n + 1) / 2, ans = -1;

    while (l <= r) {
        unsigned long long m = (l + r) / 2;

        if (pascal[n][m] >= k) {
            ans = m;
            r = m - 1;
        } else l = m + 1;
    }

    return ans;
}

int main() {

    powers[0] = 1;

    for (int i = 1; i <= 19; i++) {
        powers[i] = powers[i - 1] * 10;
    }

    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    for (unsigned long long i = 0; i < MAXN; i++) pascal[i][0] = vector <unsigned long long> (1, 1);

    for (unsigned long long i = 1; i < MAXN; i++) {
        for (unsigned long long j = 1; j <= i; j++) {
            pascal[i][j] = pascal[i - 1][j] + pascal[i - 1][j - 1];
        }
    }

    unsigned long long n, m;
    cin >> n >> m;

    for (unsigned long long i = 1; i <= n; i++) {
        cin >> a[i];
    }

    sort(a + 1, a + n + 1);

    for (unsigned long long i = 1; i <= m; i++) {
        unsigned long long l, r;
        cin >> l >> r;
        string s;
        cin >> s;

        auto k = transform_to_number(s);

        unsigned long long cnt = upper_bound(a + 1, a + n + 1, r) - lower_bound(a + 1, a + n + 1, l);
        cout << solve(cnt, k) << '\n';
    }

    return 0;

}

