#include <bits/stdc++.h>
using namespace std;

long long BASE = 1e16;

vector <long long> operator+(vector <long long>& a, vector <long long>& b) {
    vector <long long> ans;
    int prenos = 0;

    for (int i = 0; i < max(a.size(), b.size()) || prenos; i++) {
        int sum = prenos;

        if (i < a.size()) sum += a[i];
        if (i < b.size()) sum += b[i];

        prenos = sum / BASE;
        ans.push_back(sum % BASE);
    }

    return ans;
}

long long powers[20];

vector <long long> transform_to_number(string& s) {
    vector <long long> ans(1);

    int i = 0;

    while (s.size()) {
        long long digit = s.back() - '0';
        s.pop_back();

        ans.back() += powers[i] * digit;

        i++;
        if (i == 16) {
            ans.push_back(0);
            i = 0;
        }
    }

    while (ans.size() && ans.back() == 0) ans.pop_back();
    return ans;
}

bool operator>=(vector <long long>& a, vector <long long>& b) {
    if (a.size() != b.size()) return a.size() > b.size();

    for (int i = a.size() - 1; i >= 0; i--) {
        if (a[i] != b[i]) return a[i] > b[i];
    }

    return 1;
}

const long long MAXN = 500 + 10, MAXM = 1e5 + 10;
long long a[MAXN];
vector <long long> pascal[MAXN][MAXN];

long long solve(long long n, vector <long long>& k) {
    if (n == 0) return -1;
    long long l = 1, r = (n + 1) / 2, ans = -1;

    while (l <= r) {
        long long m = (l + r) / 2;

        if (pascal[n][m] >= k) {
            ans = m;
            r = m - 1;
        } else l = m + 1;
    }

    return ans;
}

int main() {

    powers[0] = 1;

    for (int i = 1; i <= 18; i++) {
        powers[i] = powers[i - 1] * 10;
    }

    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    for (long long i = 0; i < MAXN; i++) pascal[i][0] = vector <long long> (1, 1);

    for (long long i = 1; i < MAXN; i++) {
        for (long long j = 1; j <= i; j++) {
            pascal[i][j] = pascal[i - 1][j] + pascal[i - 1][j - 1];
        }
    }

    long long n, m;
    cin >> n >> m;

    for (long long i = 1; i <= n; i++) {
        cin >> a[i];
    }

    sort(a + 1, a + n + 1);

    for (long long i = 1; i <= m; i++) {
        long long l, r;
        cin >> l >> r;
        string s;
        cin >> s;

        vector <long long> k = transform_to_number(s);

        long long cnt = upper_bound(a + 1, a + n + 1, r) - lower_bound(a + 1, a + n + 1, l);
        cout << solve(cnt, k) << '\n';
    }

    return 0;

}


