#include <bits/stdc++.h>
using namespace std;

long long BASE = 1e18, NUM = 18;

struct Number{
    vector <long long> num;

    Number() : num() {}
    Number(long long x) : num(1, x) {}
};

Number operator+(Number& a, Number& b) {
    Number ans;
    long long prenos = 0;

    for (int i = 0; i < max(a.num.size(), b.num.size()) || prenos; i++) {
        long long sum = prenos;
        if (i < a.num.size()) sum += a.num[i];
        if (i < b.num.size()) sum += b.num[i];

        prenos = sum / BASE;
        ans.num.push_back(sum % BASE);
    }

    return ans;
}

long long powers[20];

vector <long long> transform_to_number(string& s) {
    vector <long long> ans(1);

    int i = 0;

    while (s.size()) {
        long long digit = s.back() - '0';
        s.pop_back();

        ans.back() += powers[i] * digit;

        i++;
        if (i == 18) {
            ans.push_back(0);
            i = 0;
        }
    }

    while (ans.size() && ans.back() == 0) ans.pop_back();
    return ans;
}

bool operator>=(Number& a, Number& b) {
    while (a.num.size() && a.num.back() == 0) a.num.pop_back();
    while (b.num.size() && b.num.back() == 0) b.num.pop_back();

    if (a.num.size() != b.num.size()) return a.num.size() > b.num.size();

    for (int i = a.num.size() - 1; i >= 0; i--) {
        if (a.num[i] != b.num[i]) return a.num[i] > b.num[i];
    }

    return 1;
}

istream& operator>>(istream& is, Number& n) {
    string s;
    is >> s;

    n.num = transform_to_number(s);
    return is;
}

#include <bits/stdc++.h>
using namespace std;

const long long MAXN = 3000 + 10, MAXM = 1e5 + 10;
long long a[MAXN];
Number pascal[MAXN][MAXN];

long long solve(long long n, Number k) {
    if (n == 0) return -1;
    long long l = 1, r = (n + 1) / 2, ans = -1;

    while (l <= r) {
        long long m = (l + r) / 2;

        if (pascal[n][m] >= k) {
            ans = m;
            r = m - 1;
        } else l = m + 1;
    }

    return ans;
}

int main() {

    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    powers[0] = 1;

    for (int i = 1; i <= 18; i++) {
        powers[i] = powers[i - 1] * 10;
    }

    for (long long i = 0; i < MAXN; i++) pascal[i][0].num = vector <long long> (1, 1);

    for (long long i = 1; i < MAXN; i++) {
        for (long long j = 1; j <= i; j++) {
            pascal[i][j] = pascal[i - 1][j] + pascal[i - 1][j - 1];
        }
    }

    long long n, m;
    cin >> n >> m;

    for (long long i = 1; i <= n; i++) {
        cin >> a[i];
    }

    sort(a + 1, a + n + 1);

    for (long long i = 1; i <= m; i++) {
        long long l, r;
        Number k;
        cin >> l >> r >> k;

        long long cnt = upper_bound(a + 1, a + n + 1, r) - lower_bound(a + 1, a + n + 1, l);
        cout << solve(cnt, k) << '\n';
    }

    return 0;

}
