#include <vector>
#include <iostream>
#include <algorithm>

const int MAX_N = 3e5 + 5;
const int MAX_Q = 5e5 + 5;
const int MAX_SQRT = 780;

namespace SegTree {
    int n;
    int fr[MAX_N + 1] = {};
    bool aint1[4 * MAX_N + 1];
    bool aint2[4 * MAX_N + 1];

    void build(int _n) {
        n = _n;
        for (int i = 1; i <= 4 * n; i++)
            aint1[i] = aint2[i] = true;
    }

    void update(int node, int st, int dr, int pos, int delta) {
        if (st == dr) {
            fr[pos] += delta;
            if (!fr[pos] || fr[pos] <= pos)
                aint1[node] = true;
            else aint1[node] = false;
            if (!fr[pos] || fr[pos] >= pos)
                aint2[node] = true;
            else aint2[node] = false;
            return;
        }
        int mij = (st + dr) / 2;
        if (pos <= mij)
            update(node * 2, st, mij, pos, delta);
        else update(node * 2 + 1, mij + 1, dr, pos, delta);
        aint1[node] = aint1[node * 2] && aint1[node * 2 + 1];
        aint2[node] = aint2[node * 2] && aint2[node * 2 + 1];
    }

    void reset() {
        build(n);
        for (int i = 1; i <= n; i++)
            fr[i] = 0;
    }

    bool query1() {
        return aint1[1];
    }

    bool query2() {
        return aint2[1];
    }
}

int DR[MAX_N + 1];
int total_fr[MAX_N + 1];
int cnt;
int v[MAX_N + 1];
bool good[MAX_N + 1];
int next_bad[MAX_N + 1];
int next_egal[MAX_N + 1];
//int nval[MAX_N + 1];
int ultim[MAX_N + 1];
int ap[MAX_N + 1];
int ptr1[MAX_N + 1];
int ptr2[MAX_N + 1];
std::vector<int> pozitii[MAX_N + 1];
long long ans = 0;
int valori[MAX_N + 1];
int prima_aparitie[MAX_N + 1];
int max_pref[MAX_N + 1];
bool nasol[MAX_N + 1];

void init(int n, int q, const std::vector<int>& A) {
    std::vector<int> a = A;
    for (int i = 0; i < n; i++)
        total_fr[a[i]]++;

    for (int i = 1; i <= n; i++) {
        if (total_fr[i] >= i) {
            good[i] = true;
            v[++cnt] = i;
        }
        else good[i] = false;
    }

    int j = 0;
    SegTree::build(n);
    for (int i = 0; i < n; i++) {
        while (j < n && SegTree::query1()) {
            SegTree::update(1, 1, n, a[j], +1);
            j++;
        }
        if (!SegTree::query1())
            DR[i] = j - 2;
        else DR[i] = j - 1;

        SegTree::update(1, 1, n, a[i], -1);
    }

    next_bad[n] = n;

    for (int i = n - 1; i >= 0; i--) {
        if (!good[a[i]])
            next_bad[i] = i;
        else next_bad[i] = next_bad[i + 1];

        DR[i] = std::min(DR[i], next_bad[i] - 1);
    }

    for (int i = n - 1; i >= 0; i--) {
        if (ap[a[i]])
            next_egal[i] = ap[a[i]];
        else next_egal[i] = n;
        ap[a[i]] = i;
    }

    int last = -1;

    for (int i = 0; i < n; i++) {
        pozitii[a[i]].push_back(i);
    }

    for (int i = 0; i < n; i++) {

        //if (last < i) last = i;
        for (int j = last + 1; j <= DR[i]; j++) {
            ultim[a[j]] = j;
        }

        last = DR[i];
        int capat_dreapta = DR[i];
        int contor = 0;

        if (i > DR[i]) continue;

        for (int k = 1; k <= cnt; k++) {
            int val = v[k];
            while (ptr1[val] < pozitii[val].size() && pozitii[val][ptr1[val]] < i)
                ptr1[val]++;

            while (ptr2[val] < pozitii[val].size() && pozitii[val][ptr2[val]] <= DR[i])
                ptr2[val]++;
            int sz = ptr2[val] - ptr1[val];
            std::cout << i << ' ' << k << ' ' << sz << '\n';

            /*valori[++contor] = val;
                prima_aparitie[val] = pozitii[val][ptr1[val]];
                continue;*/

            if (sz >= val) {
                valori[++contor] = val;
                prima_aparitie[val] = pozitii[val][ptr1[val]];
                if (sz >= val)
                    nasol[val] = false;
                else nasol[val] = true;
            }

        }

        std::sort(valori + 1, valori + contor + 1, [](int x, int y) {return prima_aparitie[x] < prima_aparitie[y];});

        max_pref[0] = 0;
        for (int k = 1; k <= contor; k++) {
            max_pref[k] = std::max(max_pref[k - 1], ultim[valori[k]]);
        }


        int nr = 0;

        for (int k = 1; k <= contor; k++) {
            if (nasol[valori[k]]) continue;

            int st = 1;
            int dr = k;
            int prf = 1;

            while (st <= dr) {
                int mij = (st + dr) / 2;
                if (prima_aparitie[valori[mij]] <= ultim[valori[k]]) {
                    prf = mij;
                    st = mij + 1;
                } else {
                    dr = mij - 1;
                }
            }

            if (max_pref[prf] <= ultim[valori[k]])
                ans++;
        }

        std::cout << i << ' ' << ans << '\n';
    }
}

long long query(int l, int r) {
    return ans;
}




int main(){
	std::ios_base::sync_with_stdio(false);
	std::cin.tie(nullptr); std::cout.tie(nullptr);
	int n, q; std::cin >> n >> q;
	std::vector<int> input(n);
	for(int i = 0; i < n; i ++){
		std::cin >> input[i];
	}
	init(n, q, input);
	for(int i = 0; i < q; i ++){
		int l, r;
		std::cin >> l >> r;
		std::cout << query(l, r) << " ";
	}
	std::cout << std::endl;
}
